
camgen := module ()

option package;

local funGtr;
local readcoef;
local ModuleLoad;

export parseXML;
export checkStoichiometry;
export loadGibbs;
export getReactionRates;
export getDerivatives;
export setIO;
export writeMcode;
export writeOutput;
export getSSprofile;
export getNH3controller;

global stateApprox;

global species;
global surface;
global gases;
global xSurf;
global xGases;
global staticGases;

global params;
global Mstates;
global Mparams;
global MstatesC;

global reactionIDs;
global reverse;
global Vmat;
global Omat;
global Gcoef;
global rr;
global geo;

global Sexp;
global Xexp;
global Texp;

global RR;
global MM;
global RLim;
global MMc;

global NH3exp;
global k1max;

global relas;
global kk;


$include "Source/parseXML.mm"
$include "Source/checkStoichiometry.mm"
$include "Source/loadGibbs.mm"
$include "Source/getReactionRates.mm"
$include "Source/getDerivatives.mm"
$include "Source/setIO.mm"
$include "Source/writeOutput.mm"
$include "Source/getSSprofile.mm"
$include "Source/getNH3controller.mm"


end module: