
checkStoichiometry := proc()

	
	local el, n, i, tmpA, tmpB;
	
	local Evec;
	local Vs;
	local Wmat;

	local elements;

	elements := [];

### START ###

	printf("CHECKING STOICHIOMETRY ...\n");


### ELEMENTS ###
	Evec := Vector(nops(species));	
	for n to nops(species) do
		Evec[n] := "";
		el := [StringTools[CaseSplit](species[n])];
		for i to nops(el) do
			if i>1 then 
				Evec[n] := cat(Evec[n],"+");
			end if;

			if StringTools[HasDigit](el[i]) then
				Evec[n] := cat(Evec[n],StringTools[Select](StringTools[IsDigit],el[i]),"*");
			end if;

			tmpB := parse(cat(StringTools[Select](StringTools[IsAlpha], el[i]),StringTools[Select](StringTools[IsPunctuation], el[i])));
			elements := [op(elements), tmpB];

			Evec[n] := cat(Evec[n],tmpB)
		end do;
	end do;

	elements := sort(ListTools[MakeUnique](elements));


### W MATRIX ###	
	
	tmpA := Vector[column](nops(elements));
	for n to nops(elements) do 
		tmpA[n] := Vector[row](nops(elements), shape = unit[n])
	end do;

	Wmat := Matrix(nops(species),nops(elements)); 
	for n to nops(species) do
		Wmat[n] := eval(parse(Evec[n]), convert(elements =~ tmpA,list));
	end do;

### CHECK STOICHIOMETRY ###

	Vs := Vmat.Wmat;
	
	for n to ArrayTools[Size](Vs)[1] do

		if ArrayTools[IsZero](Vs[n,..]) then
			printf("   Reaction (%s): Stoichiometry ok\n", cat(reactionIDs[n]));
		else
			printf("   Reaction (%s): Stoichiometry FAILED!\n", cat(reactionIDs[n]));
		end if;

	end;

	printf("DONE\n\n");

	if ArrayTools[HasNonZero](Vs) then
		error("Stoichiometry Check failed!");
	end if;

### END ###


end proc;

