
getNH3controller := proc(outputPath)


global NH3cont;

local G, fileExp, fd, NH3expp, k1fc, NH3expc, k1fmaxc;



### START ###
	printf("GET EXPLICIT NH3 CONTROLLER... \n");


### IO k1 ###

	k1fc := eval(rhs(kk(1,1)), convert(scientific, set));


### IO NH3exp ###

	G := dX(1);
	G := eval(G, RR[1]);
	G := eval(G, convert(kk(..,2), set));

	NH3exp 	:= NH3in = solve(G,NH3in);

	NH3expc := eval(NH3exp, convert(kk(..,3), set));	



### IO k1max ###


	k1fmaxc := solve(denom(rhs(NH3exp)), k1f);
	k1fmaxc := eval(k1fmaxc, convert(kk(..,3), set));

###

	NH3cont := [k1f=min(k1fc, .99*k1fmaxc), NH3expc];

	NH3cont := eval(NH3cont, convert(Gcoef, set));
	NH3cont := eval(NH3cont, convert(relas, set));
	NH3cont := eval(NH3cont, convert(scientific, set));
	NH3cont := eval(NH3cont, convert(geo, set));

	NH3cont := eval(NH3cont, convert(Mstates, set));
	NH3cont := eval(NH3cont, convert(Mparams, set));
	NH3cont := evalf(NH3cont);

### WRITE MAPLE NH3exp ###

	fileExp := cat(outputPath, "/NH3exp.m");

	fd := FileTools[Text][Open](fileExp, create = true, overwrite = true);

	fprintf(fd, "\n");
	fprintf(fd, "function NH3sp = fcn(p, mFlow, V_NH3, TKS, NH3slip) \n\n");

	fprintf(fd, "%s Generated: ",convert([37], 'bytes'));
	fprintf(fd, StringTools[FormatTime]("%Y-%m-%d %H:%M"));
	fprintf(fd, "\n\n");

	fprintf(fd, "nCells = 3;\n");
	fprintf(fd, "Vcat = 40e-3;\n\n");
	fprintf(fd, "NH3out = NH3slip;\n\n");

	fprintf(fd, "for n = nCells:-1:1\n\n");	

	FileTools[Text][Close](fd);

### GENERATED CODE

	NH3expp  := codegen[optimize](NH3cont,'tryhard');
	CodeGeneration[Matlab]([NH3expp], output=fileExp);
###
	
	fd := FileTools[Text][Open](fileExp, append=true);

	fprintf(fd, "\n");	
	fprintf(fd, "NH3out = NH3in;\n\n");
	fprintf(fd, "end\n\n");
	fprintf(fd, "NH3sp = NH3in;\n\n");
	fprintf(fd, "end"\n\n);

	FileTools[Text][Close](fd);

	printf("DONE\n\n");
### END ###

end proc;




