
getReactionRates := proc()

local n, i;
local expC0;
local conc;
local Grt;
local dGrt;


	rr := Vector();
	kk := Matrix();

### START ###
	printf("GETTING REACTION RATES ... ");


### GIBBS APPROXIMATIONS ###

	Grt :=Vector[column](nops(species));
	for n to nops(species) do
		if (ListTools[Occurrences](species[n],surface) = 1) then
			Grt[n] := cat('G_',species[n]) = 0;
#		elif (ListTools[Occurrences](species[n],xSurf) = 1) then
#			Grt[n] := cat('G_',species[n]) = cat('G_',species[n],'_a') * TKS + cat('G_',species[n],'_b');
		else
			Grt[n] := cat('G_',species[n]) = (cat('G_',species[n],'_a') * TKS + cat('G_',species[n],'_b')) / (TKS + cat('G_',species[n],'_c'));
		end if;
	end do;


### REACTION RATES ###

	conc := map2(cat, 'c', species);

	for n to ArrayTools[Size](Omat)[1] do

		rr(n) := cat('k',reactionIDs[n],'f') * ArrayTools[MultiplyAlongDimension](MTM[power](conc, map(max, Omat[n,..], 0)));
		if (reverse(n) = 1) then
			rr(n) := rr(n) - cat('k',reactionIDs[n],'b') * ArrayTools[MultiplyAlongDimension](MTM[power](conc, map(abs, map(min, Omat[n,..], 0))));
		end;


### CORRECTION FACTORS ###

		expC0 := 0;
		for i to nops(species) do
			expC0 := expC0 + Omat[n,i];
		end do;


### REACTION CONSTANTS ###

		kk(n,1) := cat('k',reactionIDs[n],'f') = cat('r',reactionIDs[n],'_A') * exp(-cat('r',reactionIDs[n],'_E')/(Rc*TKS));

		if (reverse(n) = 1) then
			dGrt := -Vmat[n].Vector[column](map2(cat, 'G_', species));
#			dGrt := -a+b/(Rc*TKS);
			kk(n,2) := cat('k',reactionIDs[n],'b') = cat('k',reactionIDs[n],'f') * c0^(expC0) / cat('K',reactionIDs[n]);
#			kk(n,2) := cat('k',reactionIDs[n],'b') = cat('k',reactionIDs[n],'f') / cat('K',reactionIDs[n]);
			kk(n,3) := cat('K',reactionIDs[n]) = exp( -eval(dGrt,convert(Grt,set)));
		else
			kk(n,2) := cat('k',reactionIDs[n],'b') = 0;
			kk(n,3) := cat('K',reactionIDs[n]) = [];
		end if;


	end do;


	rr	:= simplify(rr);


	printf("DONE\n\n");
### END ###

end proc;




