
loadGibbs := proc()


	local xmlHandle;
	local n, i;
	local Tmin, Tmax, TC, nT, bG, parG, idx;
	local spec, nasaSpecies;
	local tmpA;
	local nasa;
	local Tref;
	local rang;

	Tmin :=  300;
	Tmax := 1000;

	Gcoef := Matrix();

### START ###
	printf("PARSING NASA ... \n");

### NASA ###

	xmlHandle := XMLTools[ParseFile]("Source/NASA.xml");
	nasaSpecies := XMLTools[GetChildByName](xmlHandle, "species");
	
	nasa := Matrix(7,2);
	for n to nops(nasaSpecies) do
		spec := parse(XMLTools[AttributeValue](nasaSpecies[n], "name"));
		if (ListTools[Occurrences](spec,species) = 1) then
			
#			nasa := [op(nasa),spec];

#			p := ArrayTools[Size](nasa)[1]+1;
#			nasa := Matrix(p,4,nasa);
#			nasa(p,1) := spec;
#
			rang := XMLTools[GetChildByName](nasaSpecies[n], "range");
			Tref := parse(XMLTools[AttributeValue](rang[1], "Tref"));
			for i to nops(rang) do
				if XMLTools[AttributeValue](rang[i], "name") = "below" then
					nasa(..,1) := readcoef(XMLTools[GetChildByName](rang[i], "coef"));
				elif XMLTools[AttributeValue](rang[i], "name") = "above" then
					nasa(..,2) := readcoef(XMLTools[GetChildByName](rang[i], "coef"));
				else 
					printf("unknown range Attribute");
				end if;
			end do;

### Grt ###

			TC := Vector[column]([seq(k, k = Tmin .. Tmax, 10)]);
			nT := ArrayTools[Size](TC)[1];
	
			bG := Vector[column](nT);
			for i to nT do
				if (TC[i] < Tref) then
					bG[i] := funGtr(TC[i], nasa[..,1]);
				else
					bG[i] := funGtr(TC[i], nasa[..,2]);
				end if;
			end do;
		

			parG := Statistics[Fit]((a*T+b)/(T+c), TC, bG, T, initialvalues = [a = -30, b = -1e4, c = -10], output = parametervalues);

			tmpA := Vector[row](3);

			tmpA[1] := cat('G_',spec,'_a') = rhs(parG[1]);
			tmpA[2] := cat('G_',spec,'_b') = rhs(parG[2]);
			tmpA[3] := cat('G_',spec,'_c') = rhs(parG[3]);

			idx := ArrayTools[Size](Gcoef)[1]+1;
			Gcoef(idx,1..3) := tmpA;
			
			printf("   Approximated Gibbs for %s.\n",spec);

		end if;

	end do;


	printf("DONE\n\n");
### END ###

end proc;




readcoef := proc(coef)

	local a, i, j;

	a := Vector[column](nops(coef));
	for i to nops(coef) do
		for j to nops(coef) do
			if parse(XMLTools[AttributeValue](coef[j], "name")) = evaln(a || i) then
				a[i] := parse(XMLTools[TextText](op(3, coef[j])[1]))
			end if;
		end do;
	end do;

	return a;

end proc;


funGtr := proc(T,a) a[1]*(1-ln(T)) - a[2]*T/2 - a[3]*T^2/6 - a[4]*T^3/12 - a[5]*T^4/20 + a[6]/T - a[7]; end proc;
#funHtr := proc(T,a) a[1] + a[2]*T/2 + a[3]*T^2/3 + a[4]*T^3/4 + a[5]*T^4/5 + a[6]/T; end proc;