
setIO := proc()

	global relas;
	global scientific;
	global geo;

	local k;

	Mstates := Vector();
	Mparams := Vector();

	MstatesC := Vector();


### START ###
	printf("DEFINING INPUT/OUTPUT BEHAVIOR... ");

### RELATIONS ###

	relas := [];
	relas := [op(relas), c0 = pamb/(Rc*TKS)];
	relas := [op(relas), nFlow = mFlow / MMair];
	relas := [op(relas), sAgeo = 4*sqrt(eps * cpsi * 1550)]; # 2473
	relas := [op(relas), length = Vcat/Acs];  
	
### SCIENTIFIC ###
	
	scientific := [];
	scientific := [op(scientific), Rc = 8.3144621];
	scientific := [op(scientific), pamb = 1e5];
	scientific := [op(scientific), MMair = 29e-3];

### geo SCR ###

#	geo := [];
#	geo := [op(geo), Acs = 73e-3];
#	geo := [op(geo), eps = .8225];
#	geo := [op(geo), cpsi = 300];

#	geo := [op(geo), cpG = 1200];
#	geo := [op(geo), cpS = 400];
#	geo := [op(geo), alpha = 100];
#	geo := [op(geo), lambda = 0];
#	geo := [op(geo), weight = 1250];

### geo TWC ###

#	geo := [op(geo), Acs = 11e-3];
#	geo := [op(geo), eps = .8];
#	geo := [op(geo), cpsi = 400];

#	geo := [op(geo), alpha = 35];
#	geo := [op(geo), lambda = 0];
#	geo := [op(geo), cpG = 1200];
#	geo := [op(geo), cpS = 1000];
#	geo := [op(geo), rho = 540];


### IO X Matlab ###

	Mstates(1) := TKS = TKS[n];
	Mstates(2) := TKSnew = TKSnew[n];

	for k to numelems(xSurf) do
		Mstates(1+2*k) := xSurf[k] = parse(cat(xSurf[k],"[n]"));
		Mstates(2+2*k) := cat(xSurf[k],new) = cat(xSurf[k],new[n]);
	end do;

	MstatesC(1) := TKS = TKS[n+1];
	MstatesC(2) := TKSnew = TKS[n+1];

	for k to numelems(xSurf) do
#		MstatesC(1+2*k) := xSurf[k] = parse(cat(xSurf[k],"[n+1]"));
#		MstatesC(2+2*k) := cat(xSurf[k],new) = parse(cat(xSurf[k],"[n+1]"));
		MstatesC(1+2*k) := xSurf[k] = parse(cat(OSL,"[n+1]"));
		MstatesC(2+2*k) := cat(xSurf[k],new) = parse(cat(OSL,"[n+1]"));
	end do;

	MstatesC(5) := TKGin = tkg_in;
	MstatesC(6) := TKGout = tkg_in;

	for k to numelems(xGases) do
		MstatesC(5+2*k) := cat(xGases[k],"in") 	= evaln(exh_in[xGases[k]+1]);
		MstatesC(6+2*k) := cat(xGases[k],"out") = evaln(exh_in[xGases[k]+1]);
	end do;


#	MstatesC(7) := COin = exh_in[CO+1];
#	MstatesC(8) := O2in = exh_in[O2+1];
#	MstatesC(9) := COout = exh_in[CO+1];
#	MstatesC(10) := O2out = exh_in[O2+1];

#	MstatesC(7) := NH3in = exh_in[NH3+1];
#	MstatesC(8) := NOin = exh_in[NO+1];
#	MstatesC(9) := NH3out = exh_in[NH3+1];
#	MstatesC(10) := NOout = exh_in[NO+1];

### EXPR ###

	MM := [op(RR), op(convert(RLim,list)), op(convert(Sexp,list)), op(convert(Xexp,list)), op(convert(Texp,list))];

	MMc := MM;
	MMc := eval(MMc, convert(kk, set));	
	MMc := eval(MMc, convert(kk, set));	
	MMc := eval(MMc, convert(Gcoef, set));
	MMc := eval(MMc, convert(relas, set));
	MMc := eval(MMc, convert(scientific, set));
	MMc := eval(MMc, convert(geo, set));

#	MMc := eval(MMc, convert(Mstates, set));
	MMc := eval(MMc, convert(MstatesC, set));
	MMc := evalf(MMc);


### get params ###

	params := indets(MMc,symbol) minus (convert(map(lhs, MMc), set) union convert(map(cat,xGases,"in"),set) union {nCells,mFlow,Vcat,dt,TKGin});
	params := [op(sort(convert(params, list)))];

	for k to nops(params) do
		Mparams(k) := params[k] = evaln(p[params[k]+1]);
#		Mparams(k) := params[k] = evaln(p[k]);
	end do;

	MMc := eval(MMc, convert(Mparams, set));

	printf("DONE\n\n");
### END ###

end proc;




