

writeOutput := proc()
#	expr_in		::list,
#	mainDir		::string
#	)

global expr, vars_temps, vars, tmp;
local fileExp, fd, i, outputCode, idx, tmpA;

	printf("codegen2(%a) --> \"%s\"\n", lhs_name, output_file_name);

#	expr := expr_in;
	expr := MMc;

#
######
# GET OPTIMIZED CODE #

	expr := [codegen[optimize](expr)];
#	expr := [codegen[optimize](expr, 'tryhard')];


#
######
# GET ALL OUTPUT VARIABLES #

	vars := map(lhs, MMc);


#
######
# GET ALL TEMPORARY VARIABLES #

	vars_temps := remove(member, map(lhs, expr), vars);

	tmpA := map(rhs, expr);
	idx := ListTools[Search](n+1, tmpA);

#
######
# WRITE OUTPUT FILE #


###
fileExp := "idx.h";
fd := FileTools[Text][Open](fileExp, create = true, overwrite = true);

	fprintf(fd, "\n");
	fprintf(fd, "#define MODELNAME ""%s""\n", "TWC Model");
	fprintf(fd, "#define MODELVERSION ""%s""\n", "v1.0");
	fprintf(fd, "#define CAMGENVERSION ""%s""\n", "v0.9");
	fprintf(fd, "#define BUILDDATE ""%s""\n", StringTools[FormatTime]("%Y-%m-%d %H:%M:%S"));

	fprintf(fd, "\n");
	fprintf(fd, "#define PARAMETERS """);
	for i to numelems(params) do
		fprintf(fd, "\\t%d\\t%s\\n", i, params[i]);
	end do;
	fprintf(fd, """\n");

	fprintf(fd, "\n");
	fprintf(fd, "// gas species\n");
	fprintf(fd, "#define NGAS %d\n", numelems(xGases));

	fprintf(fd, "\n");
	for i to numelems(xGases) do
		fprintf(fd, "#define %s %d\n", xGases[i], i-1);
	end do;

	fprintf(fd, "\n");
	fprintf(fd, "// parameters\n");
	fprintf(fd, "#define NPARAMS %d\n", numelems(params));

	fprintf(fd, "\n");
	for i to numelems(params) do
		fprintf(fd, "#define %s %d\n", params[i], i-1);
	end do;

FileTools[Text][Close](fd);




fileExp := "autocode.c";
fd := FileTools[Text][Open](fileExp, create = true, overwrite = true);

	fprintf(fd, "#include <math.h>\n");
	fprintf(fd, "#include ""mex.h""\n");
	fprintf(fd, "\n");
	fprintf(fd, "#include ""idx.h""\n");
	fprintf(fd, "#include ""io.h""\n");
	fprintf(fd, "\n");
	fprintf(fd, "double tkg_out;\n");
	fprintf(fd, "double exh_out[NGAS];\n");
	fprintf(fd, "\n");
	fprintf(fd, "double *TKS;\n");
	fprintf(fd, "double *OSL;\n");
	fprintf(fd, "\n");

fprintf(fd, "void camgen_init (double tkg_us, double *exh_us)\n{\n");
	fprintf(fd, "\tint n;\n");
	fprintf(fd, "\n");
	fprintf(fd, "\tTKS = (double*)malloc(nCells*sizeof(double));\n");
	fprintf(fd, "\tOSL = (double*)malloc(nCells*sizeof(double));\n");
	fprintf(fd, "\n");
	fprintf(fd, "\tfor (n=0; n < nCells; n++){	TKS[n] = tkg_us;	OSL[n] = 0;	}\n");
	fprintf(fd, "\ttkg_out = tkg_us;\n");
	fprintf(fd, "\tfor (n=0; n<NGAS; n++){	exh_out[n] = exh_us[n];	}\n}\n");
	fprintf(fd, "\n");

fprintf(fd, "void camgen_output ()\n{\n");
	fprintf(fd, "\tint n;\n");
	fprintf(fd, "\ttkg_ds[k] = tkg_out;\n");
	fprintf(fd, "\tfor (n=0; n<NGAS; n++){	exh_ds[n+k*NGAS] = exh_out[n];	}\n");
	fprintf(fd, "\tif (nLeft > 3){	for (n=0; n<nCells; n++){	osl_ds[n+k*nCells] = OSL[n];		}}\n");
	fprintf(fd, "\tif (nLeft > 4){	for (n=0; n<nCells; n++){	tks_ds[n+k*nCells] = TKS[n];		}}\n}\n");
	fprintf(fd, "\n");

fprintf(fd, "void camgen_close()\n{\n");
	fprintf(fd, "\tfree(TKS);\n");
	fprintf(fd, "\tfree(OSL);\n}\n");
	fprintf(fd, "\n");


fprintf(fd, "void camgen_update (const double *p, double mFlow, double tkg_us, double *exh_us)\n{\n");

	for i to numelems(vars_temps) do
		if (i=idx) then
			fprintf(fd, "\tint %s;\n", vars_temps[i]);
		else
			fprintf(fd, "\tdouble %s;\n", vars_temps[i]);
		end if;
	end do;
	fprintf(fd, "\n");

	fprintf(fd, "\tdouble tkg_in;\n");
	fprintf(fd, "\tdouble exh_in[%d];\n", numelems(xGases));
	fprintf(fd, "\n");

	fprintf(fd, "\tint n;\n");
	fprintf(fd, "\tint i;\n");
	fprintf(fd, "\n");

	for i to numelems(RR) do
		fprintf(fd, "\tdouble %s;\n", lhs(RR[i]));
	end do;
	fprintf(fd, "\n");

	fprintf(fd, "\t// copy Xus to Xin\n");
	fprintf(fd, "\tfor (i=0; i<NGAS; i++)  {	exh_in[i] = exh_us[i];  };\n");
	fprintf(fd, "\tif(nLeft > 5)\n");
	fprintf(fd, "\t{\n");
	fprintf(fd, "\tfor (i=0; i<NGAS; i++)  {	exh_prof[NGAS*(nCells+1)*k+i] = exh_us[i];  };\n");
	fprintf(fd, "\t  }\n");
	fprintf(fd, "\t  tkg_in = tkg_us;\n");
	fprintf(fd, "\n");

	fprintf(fd, "// cell update\n");
	fprintf(fd, "for (n=0; n<nCells; n++)\n{\n");

	FileTools[Text][Close](fd);

	CodeGeneration[C](expr, output=fileExp);


	fd := FileTools[Text][Open](fileExp,append=true);

	fprintf(fd, "\n");
	fprintf(fd, "if(nLeft > 5)\n{\n");
	fprintf(fd, "\tfor (i=0; i<NGAS; i++)\n\t{\n");
	fprintf(fd, "\t\tint idx = NGAS*(nCells+1)*k+NGAS*(n+1)+i;\n");
	fprintf(fd, "\t\texh_prof[idx] = exh_in[i];\n");
	fprintf(fd, "\t}\n");
	fprintf(fd, "}\n");
	fprintf(fd, "}\n");
	fprintf(fd, "\n");

	fprintf(fd, "\tfor (i=0;i<NGAS;i++)  {	exh_out[i] = exh_in[i];  };\n");
	fprintf(fd, "\ttkg_out = tkg_in;\n");
	fprintf(fd, "\n");
	fprintf(fd, "}");

	FileTools[Text][Close](fd);



end proc;