camgen; % display camgen information

load paraTWC

Vcat    = 2e-4;
dtStep  = 1e-3;
dtOut   = 1e-3;

input   = [...
    [0 10 20 30]; ...           % time
    ones(1,4) * 0.03; ...       % mass flow
    ones(1,4) * 950; ...        % temperature
    [.02 .02 .015 .015]; ...    % mole fraction species 1 (CO)
    [.015 .01 .01 .01]; ...     % mole fraction species 2 (O2)
    ];

input = input';
[t_ds, exh_ds, tkg_ds] =  camgen(input', paraTWC, 20, Vcat, dtStep, dtOut);

CO_ds = exh_ds(1,:)';
O2_ds = exh_ds(2,:)';

%%
figure(1)
clf
s(1) = subplot(211);
hold on
box on
    stairs(input(:,1), input(:,4), 'b')
    stairs(input(:,1), input(:,5), 'r')
    legend('CO us','O2 us','location','ne')
    
    ylim([0 0.025])
        
s(2) = subplot(212);
hold on
box on
    plot(t_ds, CO_ds, 'b')
    plot(t_ds, O2_ds, 'r')
    legend('CO ds','O2 ds','location','ne')
    
    ylim([0 0.01])
        

